
// compile: g++ -o rectangle.ex rectangle.cpp

#include <iostream>

using namespace std;

class rectangle {
  int x, y; // by default of private access
  public:
    rectangle();
    rectangle(int xx, int yy);
    rectangle(const rectangle& r);
    void copy(rectangle r);
    void set(int xx, int yy);
    int area(void);
  };
  
  
void rectangle::set(int xx, int yy) {
  x=xx;
  y=yy;
  }
  
  
int rectangle::area(void) {
  return x*y;
  }


void rectangle::copy(rectangle r) {
  x=r.x;
  y=r.y;
  }

  
rectangle::rectangle() {
  x=0;
  y=0;
  }
  
  
rectangle::rectangle(int xx, int yy) {
  x=xx;
  y=yy;
  }
  

rectangle::rectangle(const rectangle& r) {
  x=r.x;
  y=r.y;
  }


int main()
  {

  //rectangle r;
  //cout << "r.area()=" << r.area() << endl;
  rectangle r(0,0);
  r.set(4,5);
  //cout << "r.x=" << r.x << endl;
  //cout << "r.y=" << r.y << endl;
  cout << "r.area()=" << r.area() << endl;
  
  rectangle r1(6,7);
  rectangle r2(r1);
  cout << "r2.area()=" << r2.area() << endl;
    
  int N=10;
  rectangle *s;
  s=new rectangle[N];
  s[1].set(2,7);
  cout << "s[1].area()=" << s[1].area() << endl;
  delete [] s;
  
  rectangle *p;
  rectangle w(6,7);
  p=&w;
  p->set(6,8); // memberfunction set of object pointed by p
  cout << "w.area()=" << w.area() << endl;
  
  rectangle a(4,5);
  rectangle b(3,3);
  b.copy(a);

  cout << "b.area()=" << b.area() << endl;

  return 0;
  }
  
