
// compile: g++ -o vector.ex vector.cpp

#include <iostream>

using namespace std;

class vector {
  
  public:
    
    double x, y; // a two-dimensional vector (x,y)
    
    vector() { x=0.0; y=0.0; }
    vector(double xx, double yy) { x=xx; y=yy; }
    
    vector operator+(vector arg);
    vector& operator=(const vector& arg);
    
  };
  
  
vector vector::operator+(vector arg) {
  vector tmp; // a temporary object
  tmp.x=x+arg.x;
  tmp.y=y+arg.y;
  return tmp;
  }
  
vector& vector::operator=(const vector& arg) {
  x=arg.x;
  y=arg.y;
  return *this; // to avoid a temporary object
  }
  
  
int main()
  {
  vector a(1.2,7.8);
  vector b(0.9,4.1);
  
  vector c1=a+b; // implicit call
  cout << c1.x << " " << c1.y << endl;
  
  vector c2=a.operator+(b); // explicit call 
  cout << c2.x << " " << c2.y << endl;
  
  vector c3=c2;
  cout << c3.x << " " << c3.y << endl;
  
  return 0;
  }
  
